	.module Wasp_Utilities.c
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
	.dbfunc e Delay _Delay fV
;              a -> R16
;              b -> R18
	.even
_Delay::
	.dbline -1
	.dbline 74
; /**************************************************************
; 
;    Program Title:  Wasp AVR Monitor
;    
;    Program Name:  Wasp_Utilities.c	Version: 0.75
;    
;    Author:  SS	  					  Date:  August 10, 2008
;    
;    Compiled with ImageCraft ICCAVR Standard V7.13A.
;    
;    This file contains routines that implement a set of basic utility 
;    functions for the Wasp Monitor.
;    
;    Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
;    
; ****************************************************************/
; /*
;  * Copyright 2004-2009, SOC Robotics, Inc.  All rights reserved.
;  *
;  * Redistribution and use in source and binary forms, with or without
;  * modification, are permitted provided that the following conditions
;  * are met:
;  *
;  * 1. Redistributions of source code must retain the above copyright
;  *    notice, this list of conditions and the following disclaimer.
;  * 2. Redistributions in binary form must reproduce the above copyright
;  *    notice, this list of conditions and the following disclaimer in the
;  *    documentation and/or other materials provided with the distribution.
;  * 3. Neither the name of the copyright holders nor the names of
;  *    contributors may be used to endorse or promote products derived
;  *    from this software without specific prior written permission.
;  * 4. Redistribution is only allowed in combination with SOC Machines, 
;  *    Inc. hardware products.
;  *
;  * THIS SOFTWARE IS PROVIDED BY SOC ROBOTICS, INC. AND CONTRIBUTORS
;  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
;  * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL OC MACHINES, 
;  * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
;  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
;  * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
;  * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
;  * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
;  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
;  * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
;  * SUCH DAMAGE.
;  *
;  * For additional information see http://www.soc-robotics.com
;  */
; 
; /*
;  * $Log: Wasp_Utilities.c,v $
;  * Revision 0.86  2006/02/07  SS
;  *    2-wire interface, 8MHz clock, 19,200baud
;  * Revision 0.52  2005/06/04 18:36:42  SS
;  * Preview release
;  *
;  */
; #include <iom644v.h>
; #include <macros.h>
; #include <string.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include "Wasp_Uart.h"
; #include "Wasp_Defines.h"
; #include "Wasp_Extern.h"
; 
; //*********************************************************
; //*********************************************************
; //      Utilities
; //*********************************************************
; //*********************************************************
; void Delay(void)
; {
	.dbline 77
; 	unsigned char a, b;
; 
; 	for (a = 1; a; a++)
	ldi R16,1
	xjmp L5
L2:
	.dbline 78
; 		for (b = 1; b; b++)
	ldi R18,1
	xjmp L9
L6:
	.dbline 79
; 			;
L7:
	.dbline 78
	inc R18
L9:
	.dbline 78
	tst R18
	brne L6
X0:
L3:
	.dbline 77
	inc R16
L5:
	.dbline 77
	tst R16
	brne L2
X1:
	.dbline -2
L1:
	.dbline 0 ; func end
	ret
	.dbsym r a 16 c
	.dbsym r b 18 c
	.dbend
	.dbfunc e shortdelay _shortdelay fV
;         inbyte -> R22
;              i -> R20,R21
;            cnt -> R16,R17
	.even
_shortdelay::
	xcall push_xgsetF000
	.dbline -1
	.dbline 83
; }
; 
; void shortdelay(int cnt)
; {
	.dbline 87
;  	unsigned char inbyte;
; 	int i;
; 	
;     for(i=0; i<cnt; i++)  {
	clr R20
	clr R21
	xjmp L14
L11:
	.dbline 87
	.dbline 88
; 	    inbyte = 0x55;
	ldi R22,85
	.dbline 89
; 		}
L12:
	.dbline 87
	subi R20,255  ; offset = 1
	sbci R21,255
L14:
	.dbline 87
	cp R20,R16
	cpc R21,R17
	brlt L11
X2:
	.dbline -2
L10:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 22 c
	.dbsym r i 20 I
	.dbsym r cnt 16 I
	.dbend
	.dbfunc e LongDelay _LongDelay fV
;            cnt -> R20,R21
	.even
_LongDelay::
	st -y,R20
	st -y,R21
	movw R20,R16
	.dbline -1
	.dbline 93
; }
; 
; void LongDelay(int cnt)
; {
	xjmp L17
L16:
	.dbline 94
;  	 while(cnt > 0) {
	.dbline 95
; 	 	 Delay();
	xcall _Delay
	.dbline 96
; 		 cnt--;
	subi R20,1
	sbci R21,0
	.dbline 97
; 		 }
L17:
	.dbline 94
	clr R2
	clr R3
	cp R2,R20
	cpc R3,R21
	brlt L16
X3:
	.dbline -2
L15:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r cnt 20 I
	.dbend
	.dbfunc e Delaymsec _Delaymsec fV
;     delayvalue -> R16,R17
	.even
_Delaymsec::
	.dbline -1
	.dbline 101
; }
; 
; void Delaymsec(int delayvalue)
; {
	.dbline 102
;  	 mseccountdown2 = delayvalue;
	sts _mseccountdown2+1,R17
	sts _mseccountdown2,R16
L20:
	.dbline 103
; 	 while(mseccountdown2) ;
L21:
	.dbline 103
	lds R2,_mseccountdown2
	lds R3,_mseccountdown2+1
	tst R2
	brne L20
	tst R3
	brne L20
X4:
	.dbline -2
L19:
	.dbline 0 ; func end
	ret
	.dbsym r delayvalue 16 I
	.dbend
	.dbfunc e RED_LED _RED_LED fV
;           mode -> R16
	.even
_RED_LED::
	.dbline -1
	.dbline 107
; }
; 
; void RED_LED(unsigned char mode)
; {
	.dbline 108
;  	if(mode==ON) ClrBit(PORTD,PIND5);	// low output to turn LED on
	tst R16
	brne L24
X5:
	.dbline 108
	cbi 0xb,5
	xjmp L25
L24:
	.dbline 109
; 	else SetBit(PORTD,PIND5);	// low output to turn LED off
	sbi 0xb,5
L25:
	.dbline -2
L23:
	.dbline 0 ; func end
	ret
	.dbsym r mode 16 c
	.dbend
	.dbfunc e GREEN_LED _GREEN_LED fV
;           mode -> R16
	.even
_GREEN_LED::
	.dbline -1
	.dbline 113
; }
; 
; void GREEN_LED(unsigned char mode)
; {
	.dbline 114
;  	 if(mode==ON) ClrBit(PORTD,PIND4);	
	tst R16
	brne L27
X6:
	.dbline 114
	cbi 0xb,4
	xjmp L28
L27:
	.dbline 115
; 	 else SetBit(PORTD,PIND4);	
	sbi 0xb,4
L28:
	.dbline -2
L26:
	.dbline 0 ; func end
	ret
	.dbsym r mode 16 c
	.dbend
	.dbfunc e RTEEPROMwrite _RTEEPROMwrite fV
;      savedSREG -> R10
;       databyte -> R18
;       location -> R16,R17
	.even
_RTEEPROMwrite::
	st -y,R10
	.dbline -1
	.dbline 122
; }
; 
; // Function to initiate an EEPROM write
; // writes the specified data byte to the specified location
; // this will fail if the EEPROM is not ready!
; void RTEEPROMwrite(int location, unsigned char databyte)
; {
	.dbline 124
; 	unsigned char savedSREG;
; 	EEAR = location;								// set address
	out 0x22,R17
	out 0x21,R16
	.dbline 125
; 	EEDR = databyte;								// set data	
	out 0x20,R18
	.dbline 126
; 	savedSREG = SREG;								// keep setting so it can be restored
	in R10,0x3f
	.dbline 127
; 	CLI();													// disable interrupts
	cli
	.dbline 128
; 	EECR |= BIT(EEMWE);							// set "write enable" bit
	sbi 0x1f,2
	.dbline 129
; 	EECR |= BIT(EEWE);							// set "write" bit
	sbi 0x1f,1
	.dbline 130
; 	SREG = savedSREG;								// restore SREG
	out 0x3f,R10
	.dbline 131
; 	EEAR = 0;
	clr R2
	clr R3
	out 0x22,R3
	out 0x21,R2
	.dbline -2
L29:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r savedSREG 10 c
	.dbsym r databyte 18 c
	.dbsym r location 16 I
	.dbend
	.dbfunc e RTEEPROMReady _RTEEPROMReady fc
	.even
_RTEEPROMReady::
	.dbline -1
	.dbline 137
; }
; 
; // function to test if the EEPROM is ready for a read or write operation
; // returns non zero if ready, zero if not ready 
; unsigned char RTEEPROMReady(void)
; {
	.dbline 138
; 	return !(EECR & 0x02);
	sbic 0x1f,1
	rjmp L31
X7:
	ldi R16,1
	ldi R17,0
	xjmp L32
L31:
	clr R16
	clr R17
L32:
	.dbline -2
L30:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e EEPROMWrite _EEPROMWrite fV
;       databyte -> R12
;       location -> R10,R11
	.even
_EEPROMWrite::
	xcall push_xgset003C
	mov R12,R18
	movw R10,R16
	.dbline -1
	.dbline 144
; }
; 
; // EEPROM writes take about 8ms - so poll until done
; // Do not use ICC V7 function EEPROMwrite() - this routine turns interrupts off!
; void EEPROMWrite(int location, unsigned char databyte)
; {
L34:
	.dbline 145
;  	 while(!RTEEPROMReady())  ;
L35:
	.dbline 145
	xcall _RTEEPROMReady
	tst R16
	breq L34
X8:
	.dbline 146
;  	 RTEEPROMwrite(location,databyte);
	mov R18,R12
	movw R16,R10
	xcall _RTEEPROMwrite
L37:
	.dbline 147
;  	 while(!RTEEPROMReady())  ;
L38:
	.dbline 147
	xcall _RTEEPROMReady
	tst R16
	breq L37
X9:
	.dbline -2
L33:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r databyte 12 c
	.dbsym r location 10 I
	.dbend
	.dbfunc e WriteEEPROM _WriteEEPROM fV
;              i -> R20,R21
;           strg -> R10,R11
;       location -> R12,R13
	.even
_WriteEEPROM::
	xcall push_xgset303C
	movw R10,R18
	movw R12,R16
	.dbline -1
	.dbline 152
; }
; 
; // Write a string of characters to EEPROM at specified start location
; void WriteEEPROM(int location, unsigned char *strg)
; {
	.dbline 155
;  	 int i;
; 	 
; 	 i = 0;
	clr R20
	clr R21
	xjmp L42
L41:
	.dbline 156
; 	 while(strg[i] != 0x00)  {
	.dbline 157
; 	     EEPROMWrite(location+i,strg[i]);
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R18,z+0
	movw R16,R12
	add R16,R20
	adc R17,R21
	xcall _EEPROMWrite
	.dbline 158
; 		 i++;
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 159
; 		 }
L42:
	.dbline 156
	movw R30,R20
	add R30,R10
	adc R31,R11
	ldd R2,z+0
	tst R2
	brne L41
X10:
	.dbline -2
L40:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 20 I
	.dbsym r strg 10 pc
	.dbsym r location 12 I
	.dbend
	.dbfunc e BlinkGreen _BlinkGreen fV
;         period -> R10,R11
	.even
_BlinkGreen::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 163
; }
; 
; void BlinkGreen(int period)
; {
	.dbline 164
;  	 GREEN_LED(ON);
	clr R16
	xcall _GREEN_LED
	.dbline 165
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline 166
; 	 GREEN_LED(OFF);
	ldi R16,1
	xcall _GREEN_LED
	.dbline 167
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline -2
L44:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r period 10 I
	.dbend
	.dbfunc e BlinkRed _BlinkRed fV
;         period -> R10,R11
	.even
_BlinkRed::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 171
; }
; 
; void BlinkRed(int period)
; {
	.dbline 172
;  	 RED_LED(ON);
	clr R16
	xcall _RED_LED
	.dbline 173
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline 174
; 	 RED_LED(OFF);
	ldi R16,1
	xcall _RED_LED
	.dbline 175
; 	 LongDelay(period);
	movw R16,R10
	xcall _LongDelay
	.dbline -2
L45:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r period 10 I
	.dbend
	.dbfunc e PrintHex _PrintHex fV
;         inbyte -> R10
	.even
_PrintHex::
	st -y,R10
	mov R10,R16
	.dbline -1
	.dbline 179
; }
; 
; void PrintHex(unsigned char inbyte)
; {
	.dbline 181
;      //printf("%2x",inbyte);
;  	 bytetohex(inbyte);
	mov R16,R10
	xcall _bytetohex
	.dbline 182
; 	 puts(hexbyte);
	ldi R16,<_hexbyte
	ldi R17,>_hexbyte
	xcall _puts
	.dbline -2
L46:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inbyte 10 c
	.dbend
	.dbfunc e PrintWordHex _PrintWordHex fV
;         inword -> R10,R11
	.even
_PrintWordHex::
	st -y,R10
	st -y,R11
	movw R10,R16
	.dbline -1
	.dbline 186
; }
; 
; void PrintWordHex(unsigned int inword)
; {
	.dbline 188
;  	 //printf("%4x",inword);
;  	 addresstohex(inword);
	movw R16,R10
	xcall _addresstohex
	.dbline 189
; 	 puts(hexaddress);
	ldi R16,<_hexaddress
	ldi R17,>_hexaddress
	xcall _puts
	.dbline -2
L47:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	ret
	.dbsym r inword 10 i
	.dbend
	.dbfunc e EEPROMSetup _EEPROMSetup fV
	.even
_EEPROMSetup::
	.dbline -1
	.dbline 194
; }
; 
; //  TBD
; void EEPROMSetup(void)
; {
	.dbline -2
L48:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ReadAVRFlash _ReadAVRFlash fc
;          rbyte -> R10
;      flashbyte -> R10
;        address -> <dead>
	.even
_ReadAVRFlash::
	st -y,r17
	st -y,r16
	st -y,R10
	.dbline -1
	.dbline 200
;  	
; }
; 
; //  Access contents of AVR flash at specified address
; unsigned char ReadAVRFlash(int address)
; {
	.dbline 203
;  	unsigned char flashbyte,rbyte;
; 	
; 	flashbyte = 0;
	clr R10
	.dbline 204
;  	asm("mov r30,r16 \n"
	mov r30,r16 
	mov r31,r17 
	lpm r0,Z 
	mov R10,r0 
	
	.dbline 208
;        "mov r31,r17 \n"
; 	   "lpm r0,Z \n"
; 	   "mov %flashbyte,r0 \n"); 
; 	rbyte = flashbyte;  
	.dbline 209
; 	return(rbyte);                              
	mov R16,R10
	.dbline -2
L49:
	.dbline 0 ; func end
	ld R10,y+
	adiw R28,2
	ret
	.dbsym r rbyte 10 c
	.dbsym r flashbyte 10 c
	.dbsym l address 1 I
	.dbend
	.dbfunc e signon _signon fV
	.even
_signon::
	.dbline -1
	.dbline 214
; }
; 
; //  Output sign on message loaded from Flash
; void signon()
; {
	.dbline 215
; 	putfs(signon1);
	ldi R16,<_signon1
	ldi R17,>_signon1
	xcall _putfs
	.dbline 216
; 	putfs(signon2);
	ldi R16,<_signon2
	ldi R17,>_signon2
	xcall _putfs
	.dbline 217
; 	CheckFlashTypes();
	xcall _CheckFlashTypes
	.dbline 218
; 	putfs(signon3);
	ldi R16,<_signon3
	ldi R17,>_signon3
	xcall _putfs
	.dbline 219
; 	putfs(signon4);
	ldi R16,<_signon4
	ldi R17,>_signon4
	xcall _putfs
	.dbline 220
; 	putfs(signon5);
	ldi R16,<_signon5
	ldi R17,>_signon5
	xcall _putfs
	.dbline 221
; 	putfs(signon6);
	ldi R16,<_signon6
	ldi R17,>_signon6
	xcall _putfs
	.dbline 222
; 	putfs(signon62);
	ldi R16,<_signon62
	ldi R17,>_signon62
	xcall _putfs
	.dbline 223
; 	putfs(signon65);
	ldi R16,<_signon65
	ldi R17,>_signon65
	xcall _putfs
	.dbline 224
; 	putfs(signon66);
	ldi R16,<_signon66
	ldi R17,>_signon66
	xcall _putfs
	.dbline 225
; 	putfs(signon67);
	ldi R16,<_signon67
	ldi R17,>_signon67
	xcall _putfs
	.dbline 226
; 	putfs(signon7);
	ldi R16,<_signon7
	ldi R17,>_signon7
	xcall _putfs
	.dbline 227
; 	putfs(signon8);
	ldi R16,<_signon8
	ldi R17,>_signon8
	xcall _putfs
	.dbline 228
; 	putfs(signon83);
	ldi R16,<_signon83
	ldi R17,>_signon83
	xcall _putfs
	.dbline 229
; 	putfs(signon85);
	ldi R16,<_signon85
	ldi R17,>_signon85
	xcall _putfs
	.dbline 230
; 	putfs(signon9);
	ldi R16,<_signon9
	ldi R17,>_signon9
	xcall _putfs
	.dbline -2
L50:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e DisplayEEPROM _DisplayEEPROM fV
;       numlines -> y+5
; bytesonlastline -> y+4
;        linecnt -> y+2
;      tempvalue -> R20
;       asciicnt -> y+1
;     newaddress -> R12,R13
;       crcvalue -> y+0
;           byte -> R22
;              i -> R10
;       numbytes -> R10,R11
;        address -> y+17
	.even
_DisplayEEPROM::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,7
	.dbline -1
	.dbline 236
; }
; 
; 
; //  Display AVR EEPROM memory
; void DisplayEEPROM(int address,int numbytes)
; {
	.dbline 240
;  	 unsigned char i,byte,bytesonlastline,asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+1,R0
	clr R2
	clr R3
	std y+3,R3
	std y+2,R2
	.dbline 241
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 242
; 	 numlines = numbytes/bytesonline;
	movw R18,R24
	movw R16,R10
	xcall div16u
	std y+6,R17
	std y+5,R16
	.dbline 243
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	xcall empy16s
	movw R2,R10
	sub R2,R16
	sbc R3,R17
	std y+4,R2
	xjmp L53
L52:
	.dbline 244
; 	 while(linecnt<numlines) {
	.dbline 245
; 	     crcvalue = 0;
	clr R0
	std y+0,R0
	.dbline 246
; 	     putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 247
; 		 PrintHex(bytesonline);		 //  Output bytes on line
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 248
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	ldd R4,y+0
	clr R5
	add R4,R2
	adc R5,R3
	std y+0,R4
	.dbline 250
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	ldd R12,y+17
	ldd R13,y+18
	add R12,R16
	adc R13,R17
	.dbline 251
; 	     PrintWordHex(newaddress);
	movw R16,R12
	xcall _PrintWordHex
	.dbline 252
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R12
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 253
; 		 crcvalue += tempvalue;
	ldd R0,y+0
	add R0,R20
	std y+0,R0
	.dbline 254
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R12
	andi R21,0
	.dbline 255
; 		 crcvalue += tempvalue;
	add R0,R20
	std y+0,R0
	.dbline 257
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L55
	ldi R17,>L55
	xcall _puts
	.dbline 259
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L59
L56:
	.dbline 259
	.dbline 260
; 	         byte = EEPROM_read(i+newaddress);
	mov R16,R10
	clr R17
	add R16,R12
	adc R17,R13
	xcall _EEPROM_read
	mov R22,R16
	.dbline 261
; 			 ascii[asciicnt++] = byte;
	ldd R2,y+1
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+1,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 262
; 			 crcvalue += byte;
	ldd R0,y+0
	add R0,R16
	std y+0,R0
	.dbline 263
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 264
; 	         }
L57:
	.dbline 259
	inc R10
L59:
	.dbline 259
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L56
X11:
	.dbline 265
; 		 linecnt++;
	ldd R24,y+2
	ldd R25,y+3
	adiw R24,1
	std y+3,R25
	std y+2,R24
	.dbline 266
; 		 asciicnt = 0;
	clr R0
	std y+1,R0
	.dbline 268
; 		 // Output CRC
; 		 PrintHex((~crcvalue)+0x01);
	ldd R16,y+0
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 269
; 	     puts("  ");
	ldi R16,<L60
	ldi R17,>L60
	xcall _puts
	.dbline 270
; 		 for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L64
L61:
	.dbline 270
	.dbline 271
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R14,z+0
	clr R15
	ldi R24,31
	cp R24,R14
	brsh L65
X12:
	mov R24,R14
	cpi R24,128
	brsh L65
X13:
	.dbline 271
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putcharr
	xjmp L66
L65:
	.dbline 272
; 			 else putcharr('.');
	ldi R16,46
	xcall _putcharr
L66:
	.dbline 273
; 			 }
L62:
	.dbline 270
	inc R10
L64:
	.dbline 270
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L61
X14:
	.dbline 274
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 275
; 		 }
L53:
	.dbline 244
	ldd R0,y+2
	ldd R1,y+3
	ldd R16,y+5
	ldd R17,y+6
	cp R0,R16
	cpc R1,R17
	brge X21
	xjmp L52
X21:
X15:
	.dbline 276
; 	 if(bytesonlastline) {
	ldd R0,y+4
	tst R0
	brne X22
	xjmp L67
X22:
X16:
	.dbline 276
	.dbline 277
; 	     crcvalue = 0;
	clr R0
	std y+0,R0
	.dbline 278
; 	     putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 280
; 		 //  Output bytes on line
; 		 PrintHex(bytesonlastline);
	ldd R16,y+4
	xcall _PrintHex
	.dbline 281
; 		 crcvalue += bytesonlastline;
	ldd R0,y+0
	ldd R16,y+4
	add R0,R16
	std y+0,R0
	.dbline 283
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	ldd R12,y+17
	ldd R13,y+18
	add R12,R16
	adc R13,R17
	.dbline 284
; 	     addresstohex(newaddress);
	movw R16,R12
	xcall _addresstohex
	.dbline 285
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R20,R12
	andi R20,0
	mov R20,R21
	clr R21
	.dbline 286
; 		 crcvalue += tempvalue;
	ldd R0,y+0
	add R0,R20
	std y+0,R0
	.dbline 287
; 		 tempvalue = newaddress&0x00ff;
	mov R20,R12
	andi R21,0
	.dbline 288
; 		 crcvalue += tempvalue;
	add R0,R20
	std y+0,R0
	.dbline 289
; 	     puts(hexaddress);
	ldi R16,<_hexaddress
	ldi R17,>_hexaddress
	xcall _puts
	.dbline 291
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L55
	ldi R17,>L55
	xcall _puts
	.dbline 293
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L72
L69:
	.dbline 293
	.dbline 294
; 	         byte = EEPROM_read(i+address+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+2
	ldd R19,y+3
	xcall empy16s
	movw R2,R16
	mov R16,R10
	clr R17
	ldd R0,y+17
	ldd R1,y+18
	add R16,R0
	adc R17,R1
	add R16,R2
	adc R17,R3
	xcall _EEPROM_read
	mov R20,R16
	mov R22,R20
	.dbline 295
; 			 ascii[asciicnt++] = byte;
	ldd R20,y+1
	clr R21
	mov R24,R20
	subi R24,255    ; addi 1
	std y+1,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 296
; 			 crcvalue += byte;
	ldd R0,y+0
	add R0,R16
	std y+0,R0
	.dbline 297
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 298
; 	         }
L70:
	.dbline 293
	inc R10
L72:
	.dbline 293
	ldd R0,y+4
	cp R10,R0
	brlo L69
X17:
	.dbline 300
; 		 // Output CRC
; 		 PrintHex((~crcvalue)+0x01);
	ldd R16,y+0
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 301
; 	     puts("  ");
	ldi R16,<L60
	ldi R17,>L60
	xcall _puts
	.dbline 302
; 		 for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L76
L73:
	.dbline 302
	.dbline 303
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L77
X18:
	cpi R20,128
	brsh L77
X19:
	.dbline 303
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putcharr
	xjmp L78
L77:
	.dbline 304
; 			 else putcharr('.');
	ldi R16,46
	xcall _putcharr
L78:
	.dbline 305
; 			 }
L74:
	.dbline 302
	inc R10
L76:
	.dbline 302
	ldd R0,y+4
	cp R10,R0
	brlo L73
X20:
	.dbline 306
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 307
; 		 }
L67:
	.dbline -2
L51:
	.dbline 0 ; func end
	adiw R28,7
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l numlines 5 I
	.dbsym l bytesonlastline 4 c
	.dbsym l linecnt 2 I
	.dbsym r tempvalue 20 c
	.dbsym l asciicnt 1 c
	.dbsym r newaddress 12 I
	.dbsym l crcvalue 0 c
	.dbsym r byte 22 c
	.dbsym r i 10 c
	.dbsym r numbytes 10 I
	.dbsym l address 17 I
	.dbend
	.dbfunc e DisplayAVRFlash _DisplayAVRFlash fV
;       numlines -> y+3
; bytesonlastline -> R12
;     newaddress -> R20,R21
;      tempvalue -> R10
;       asciicnt -> y+2
;        linecnt -> y+0
;       crcvalue -> R14
;           byte -> R22
;              i -> R10
;       numbytes -> R10,R11
;        address -> y+15
	.even
_DisplayAVRFlash::
	xcall push_arg4
	xcall push_xgsetF0FC
	movw R10,R18
	sbiw R28,5
	.dbline -1
	.dbline 312
; }
; 
; //  Display P1 AVR Flash memory
; void DisplayAVRFlash(int address,int numbytes)
; {
	.dbline 316
;  	 unsigned char i,byte,bytesonlastline,asciicnt,crcvalue,tempvalue;
; 	 int linecnt,numlines,newaddress;
; 
; 	 linecnt = asciicnt = 0;
	clr R0
	std y+2,R0
	clr R2
	clr R3
	std y+1,R3
	std y+0,R2
	.dbline 317
; 	 bytesonline = 16;	 
	ldi R24,16
	ldi R25,0
	sts _bytesonline+1,R25
	sts _bytesonline,R24
	.dbline 318
; 	 numlines = numbytes/bytesonline;
	movw R18,R24
	movw R16,R10
	xcall div16u
	std y+4,R17
	std y+3,R16
	.dbline 319
; 	 bytesonlastline = numbytes - numlines*bytesonline;
	lds R18,_bytesonline
	lds R19,_bytesonline+1
	xcall empy16s
	mov R12,R10
	sub R12,R16
	sbc R13,R17
	xjmp L81
L80:
	.dbline 320
; 	 while(linecnt<numlines) {
	.dbline 321
; 	 	 crcvalue = 0;
	clr R14
	.dbline 322
; 	     putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 324
; 		 //  Output bytes on line
; 		 PrintHex(bytesonline);
	lds R16,_bytesonline
	xcall _PrintHex
	.dbline 325
; 		 crcvalue += bytesonline;
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R14
	clr R5
	add R4,R2
	adc R5,R3
	mov R14,R4
	.dbline 327
; 	     //  Output hex start address
; 		 newaddress = address+linecnt*16;
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	ldd R20,y+15
	ldd R21,y+16
	add R20,R16
	adc R21,R17
	.dbline 328
; 	     PrintWordHex(newaddress);
	movw R16,R20
	xcall _PrintWordHex
	.dbline 329
; 		 tempvalue = (newaddress&0xff00)>>8;
	movw R24,R20
	andi R24,0
	movw R10,R24
	mov R10,R11
	clr R11
	.dbline 330
; 		 crcvalue += tempvalue;
	add R14,R10
	.dbline 331
; 		 tempvalue = newaddress&0x00ff;
	movw R24,R20
	andi R25,0
	.dbline 332
; 		 crcvalue += tempvalue;
	add R14,R24
	.dbline 334
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L55
	ldi R17,>L55
	xcall _puts
	.dbline 336
; 		 //  Output data
; 	     for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L86
L83:
	.dbline 336
	.dbline 337
; 	         byte = ReadAVRFlash(address+i+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	movw R2,R16
	mov R4,R10
	clr R5
	ldd R16,y+15
	ldd R17,y+16
	add R16,R4
	adc R17,R5
	add R16,R2
	adc R17,R3
	xcall _ReadAVRFlash
	mov R22,R16
	.dbline 338
; 			 ascii[asciicnt++] = byte;
	ldd R2,y+2
	clr R3
	mov R24,R2
	subi R24,255    ; addi 1
	std y+2,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R2
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 339
; 			 crcvalue += byte;
	add R14,R16
	.dbline 340
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 341
; 	         }
L84:
	.dbline 336
	inc R10
L86:
	.dbline 336
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L83
X23:
	.dbline 342
; 		 linecnt++;
	ldd R24,y+0
	ldd R25,y+1
	adiw R24,1
	std y+1,R25
	std y+0,R24
	.dbline 343
; 		 asciicnt = 0;
	clr R0
	std y+2,R0
	.dbline 345
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	mov R16,R14
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 346
; 	     puts("  ");
	ldi R16,<L60
	ldi R17,>L60
	xcall _puts
	.dbline 347
; 		 for(i=0; i<bytesonline; i++) {
	clr R10
	xjmp L90
L87:
	.dbline 347
	.dbline 348
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L91
X24:
	cpi R20,128
	brsh L91
X25:
	.dbline 348
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putcharr
	xjmp L92
L91:
	.dbline 349
; 			 else putcharr('.');
	ldi R16,46
	xcall _putcharr
L92:
	.dbline 350
; 			 }
L88:
	.dbline 347
	inc R10
L90:
	.dbline 347
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L87
X26:
	.dbline 351
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 352
; 		 }
L81:
	.dbline 320
	ldd R0,y+0
	ldd R1,y+1
	ldd R16,y+3
	ldd R17,y+4
	cp R0,R16
	cpc R1,R17
	brge X33
	xjmp L80
X33:
X27:
	.dbline 353
; 	 if(bytesonlastline) {
	tst R12
	brne X34
	xjmp L93
X34:
X28:
	.dbline 353
	.dbline 354
; 	     crcvalue = 0;
	clr R14
	.dbline 355
; 	     putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 357
; 		 //  Output bytes on line
; 		 PrintHex(bytesonlastline);
	mov R16,R12
	xcall _PrintHex
	.dbline 359
; 	     //  Output hex start address
; 	     PrintWordHex(address+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	movw R2,R16
	ldd R16,y+15
	ldd R17,y+16
	add R16,R2
	adc R17,R3
	xcall _PrintWordHex
	.dbline 361
; 		 //  Output 00
; 		 puts("00");
	ldi R16,<L55
	ldi R17,>L55
	xcall _puts
	.dbline 363
; 		 //  Output data
; 	     for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L98
L95:
	.dbline 363
	.dbline 364
; 	         byte = ReadAVRFlash(address+i+linecnt*16);
	ldi R16,16
	ldi R17,0
	ldd R18,y+0
	ldd R19,y+1
	xcall empy16s
	movw R2,R16
	mov R4,R10
	clr R5
	ldd R16,y+15
	ldd R17,y+16
	add R16,R4
	adc R17,R5
	add R16,R2
	adc R17,R3
	xcall _ReadAVRFlash
	mov R20,R16
	mov R22,R20
	.dbline 365
; 			 ascii[asciicnt++] = byte;
	ldd R20,y+2
	clr R21
	mov R24,R20
	subi R24,255    ; addi 1
	std y+2,R24
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R22
	.dbline 366
; 			 crcvalue += byte;
	add R14,R16
	.dbline 367
; 	         PrintHex(byte);
	xcall _PrintHex
	.dbline 368
; 	         }
L96:
	.dbline 363
	inc R10
L98:
	.dbline 363
	cp R10,R12
	brlo L95
X29:
	.dbline 370
; 		 // Output CRC
; 	     PrintHex((~crcvalue)+0x01);
	mov R16,R14
	com R16
	subi R16,255    ; addi 1
	xcall _PrintHex
	.dbline 371
; 	     puts("  ");
	ldi R16,<L60
	ldi R17,>L60
	xcall _puts
	.dbline 372
; 		 for(i=0; i<bytesonlastline; i++) {
	clr R10
	xjmp L102
L99:
	.dbline 372
	.dbline 373
; 		     if(ascii[i]>0x1F&&ascii[i]<0x80)  putcharr(ascii[i]);
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	ldi R24,31
	cp R24,R20
	brsh L103
X30:
	cpi R20,128
	brsh L103
X31:
	.dbline 373
	ldi R24,<_ascii
	ldi R25,>_ascii
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _putcharr
	xjmp L104
L103:
	.dbline 374
; 			 else putcharr('.');
	ldi R16,46
	xcall _putcharr
L104:
	.dbline 375
; 			 }
L100:
	.dbline 372
	inc R10
L102:
	.dbline 372
	cp R10,R12
	brlo L99
X32:
	.dbline 376
; 	     putCRLF();  
	xcall _putCRLF
	.dbline 377
; 		 }
L93:
	.dbline -2
L79:
	.dbline 0 ; func end
	adiw R28,5
	xcall pop_xgsetF0FC
	adiw R28,4
	ret
	.dbsym l numlines 3 I
	.dbsym r bytesonlastline 12 c
	.dbsym r newaddress 20 I
	.dbsym r tempvalue 10 c
	.dbsym l asciicnt 2 c
	.dbsym l linecnt 0 I
	.dbsym r crcvalue 14 c
	.dbsym r byte 22 c
	.dbsym r i 10 c
	.dbsym r numbytes 10 I
	.dbsym l address 15 I
	.dbend
	.dbfunc e hextobyte _hextobyte fc
;         inbyte -> R16
	.even
_hextobyte::
	xcall push_xgsetF000
	.dbline -1
	.dbline 381
; }
; 
; unsigned char hextobyte(unsigned char inbyte)
; {
	.dbline 382
; 	 if((inbyte >= 'A')&(inbyte<='F')) return (inbyte - 'A' + 10);
	cpi R16,65
	brlo L108
X35:
	ldi R22,1
	ldi R23,0
	xjmp L109
L108:
	clr R22
	clr R23
L109:
	ldi R24,70
	cp R24,R16
	brlo L110
X36:
	ldi R20,1
	ldi R21,0
	xjmp L111
L110:
	clr R20
	clr R21
L111:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X37
	tst R3
	breq L106
X37:
	.dbline 382
	mov R24,R16
	subi R24,65
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L105
L106:
	.dbline 383
; 	 if((inbyte >= 'a')&(inbyte<='f')) return (inbyte - 'a' + 10);
	cpi R16,97
	brlo L114
X38:
	ldi R22,1
	ldi R23,0
	xjmp L115
L114:
	clr R22
	clr R23
L115:
	ldi R24,102
	cp R24,R16
	brlo L116
X39:
	ldi R20,1
	ldi R21,0
	xjmp L117
L116:
	clr R20
	clr R21
L117:
	movw R2,R22
	and R2,R20
	and R3,R21
	tst R2
	brne X40
	tst R3
	breq L112
X40:
	.dbline 383
	mov R24,R16
	subi R24,97
	subi R24,246    ; addi 10
	mov R16,R24
	xjmp L105
L112:
	.dbline 384
; 	 else return (inbyte - '0');
	subi R16,48
	.dbline -2
L105:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r inbyte 16 c
	.dbend
	.dbfunc e ScanHex _ScanHex fi
;        address -> R10,R11
;            len -> R12
;              i -> R20
	.even
_ScanHex::
	xcall push_xgsetF0FC
	.dbline -1
	.dbline 390
; }
; 
; // Read in a hex string and convert to int or long
; //  TBD - add long support for serial flash support
; unsigned int  ScanHex()
; {
	.dbline 392
;  	 unsigned int  address;
;  	 char i=0,len;
	clr R20
	.dbline 394
; 	 
; 	 address = 0;
	clr R10
	clr R11
	.dbline 395
; 	 putcharr((instrg[0]=getcharr()));
	xcall _getcharr
	sts _instrg,R16
	xcall _putcharr
	xjmp L120
L119:
	.dbline 396
;  	 while((instrg[i]!=CR)&&(instrg[i]!=' ')) {
	.dbline 397
; 	 	 i++;
	inc R20
	.dbline 398
; 	     putcharr((instrg[i]=getcharr()));
	xcall _getcharr
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	std z+0,R16
	xcall _putcharr
	.dbline 399
; 		 }
L120:
	.dbline 396
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R22,z+0
	clr R23
	cpi R22,13
	breq L122
X41:
	cpi R22,32
	brne L119
X42:
L122:
	.dbline 400
; 	 instrg[i] = 0;
	ldi R24,<_instrg
	ldi R25,>_instrg
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
	.dbline 401
; 	 len = strlen(instrg);
	ldi R16,<_instrg
	ldi R17,>_instrg
	xcall _strlen
	movw R12,R16
	.dbline 402
; 	 address = hextobyte(instrg[len-1]);
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	mov R30,R12
	clr R31
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R10,R14
	clr R11
	.dbline 403
; 	 i = 1;
	ldi R20,1
	xjmp L125
L124:
	.dbline 404
; 	 while(i<len) {
	.dbline 405
; 	     if(i==1) address += (hextobyte(instrg[len-i-1])*16);
	cpi R20,1
	brne L127
X43:
	.dbline 405
	mov R2,R20
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	ldi R24,16
	mul R24,R14
	add R10,R0
	adc R11,R1
L127:
	.dbline 406
; 	     if(i==2) address += (hextobyte(instrg[len-i-1])*256);
	cpi R20,2
	brne L130
X44:
	.dbline 406
	mov R2,R20
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R18,R14
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	add R10,R16
	adc R11,R17
L130:
	.dbline 407
; 	     if(i==3) address += (hextobyte(instrg[len-i-1])*4096);
	cpi R20,3
	brne L133
X45:
	.dbline 407
	mov R2,R20
	clr R3
	mov R30,R12
	clr R31
	sub R30,R2
	sbc R31,R3
	ldi R24,<_instrg-1
	ldi R25,>_instrg-1
	add R30,R24
	adc R31,R25
	ldd R16,z+0
	xcall _hextobyte
	mov R14,R16
	mov R18,R14
	clr R19
	ldi R16,4096
	ldi R17,16
	xcall empy16s
	add R10,R16
	adc R11,R17
L133:
	.dbline 408
; 		 i++;
	inc R20
	.dbline 409
; 		 }
L125:
	.dbline 404
	cp R20,R12
	brsh X47
	xjmp L124
X47:
X46:
	.dbline 410
; 	 return address;
	movw R16,R10
	.dbline -2
L118:
	.dbline 0 ; func end
	xjmp pop_xgsetF0FC
	.dbsym r address 10 i
	.dbsym r len 12 c
	.dbsym r i 20 c
	.dbend
	.dbfunc e GetByteHex _GetByteHex fc
;           strg -> y+0
	.even
_GetByteHex::
	st -y,R10
	sbiw R28,3
	.dbline -1
	.dbline 414
; }
; 
; unsigned char GetByteHex()
; {
	.dbline 419
;  	 char strg[3];
; 	 
; //	 putcharr((strg[0]=getchar()));
; //	 putcharr((strg[1]=getchar()));
; 	 strg[0]=getcharr();
	xcall _getcharr
	std y+0,R16
	.dbline 420
; 	 strg[1]=getcharr();
	xcall _getcharr
	std y+1,R16
	.dbline 421
; 	 strg[2] = 0;
	clr R2
	std y+2,R2
	.dbline 422
; 	 return converttohex(strg);
	movw R16,R28
	xcall _converttohex
	mov R10,R16
	.dbline -2
L136:
	.dbline 0 ; func end
	adiw R28,3
	ld R10,y+
	ret
	.dbsym l strg 0 A[3:3]c
	.dbend
	.dbfunc e DisplayMemory _DisplayMemory fV
;         length -> R12,R13
;        address -> R10,R11
;         inchar -> R14
	.even
_DisplayMemory::
	xcall push_xgset30FC
	sbiw R28,1
	.dbline -1
	.dbline 426
; }
; 
; void DisplayMemory(void)
; {
	.dbline 430
;     unsigned char inchar;
; 	unsigned int address, length;
; 	
; 	inchar = getcharr();
	xcall _getcharr
	mov R14,R16
	.dbline 431
; 	putcharr(inchar);
	xcall _putcharr
	.dbline 432
; 	putCRLF();
	xcall _putCRLF
	.dbline 433
; 	putfs(displaymessage1);
	ldi R16,<_displaymessage1
	ldi R17,>_displaymessage1
	xcall _putfs
	.dbline 434
; 	address = ScanHex();
	xcall _ScanHex
	movw R10,R16
	.dbline 435
; 	length = ScanHex();
	xcall _ScanHex
	movw R12,R16
	.dbline 436
; 	putCRLF();
	xcall _putCRLF
	.dbline 437
; 	switch (inchar) {
	mov R20,R14
	clr R21
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	breq L144
X48:
	cpi R20,66
	ldi R30,0
	cpc R21,R30
	breq L146
X49:
	cpi R20,69
	ldi R30,0
	cpc R21,R30
	breq L143
X50:
	cpi R20,70
	ldi R30,0
	cpc R21,R30
	breq L145
X51:
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	brlt L140
X52:
L147:
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L144
X53:
	cpi R20,98
	ldi R30,0
	cpc R21,R30
	breq L146
X54:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L143
X55:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L145
X56:
	xjmp L140
L143:
	.dbline 439
; 	    case 'e': case 'E':
; 			DisplayEEPROM(address,length);
	movw R18,R12
	movw R16,R10
	xcall _DisplayEEPROM
	.dbline 440
; 		    break;
	xjmp L141
L144:
	.dbline 442
; 		case 'a': case 'A':
; 		    DisplayAVRFlash(address,length);
	movw R18,R12
	movw R16,R10
	xcall _DisplayAVRFlash
	.dbline 443
; 		    break;
	xjmp L141
L145:
	.dbline 449
; 		//  In order to access Blackfin Flash the AVR must ask the Blackfin
; 		//  to release control of the SPI lines.  This is simulated in Rev A
; 		//  boards by resetting the Blackfin (which should release the SPI lines)
; 		//  On completion the AVR SPI lines are released.
; 		case 'f': case 'F':
; 			Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 450
; 		    DisplaySerialFlash(address,length,READCONTINUOUS);	
	ldi R24,1
	std y+0,R24
	movw R18,R12
	movw R16,R10
	xcall _DisplaySerialFlash
	.dbline 451
; 			Release_SPI();
	xcall _Release_SPI
	.dbline 452
; 		    break;
	xjmp L141
L146:
	.dbline 454
; 		case 'b': case 'B':
; 			Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 455
; 		    DisplaySerialFlash(address,length,READBUFFER);			
	ldi R24,2
	std y+0,R24
	movw R18,R12
	movw R16,R10
	xcall _DisplaySerialFlash
	.dbline 456
; 			Release_SPI();
	xcall _Release_SPI
	.dbline 457
; 		    break;
	xjmp L141
L140:
	.dbline 459
; 		default:
; 		    putfs(displaymessage33);
	ldi R16,<_displaymessage33
	ldi R17,>_displaymessage33
	xcall _putfs
	.dbline 460
; 		    break;
L141:
	.dbline -2
L139:
	.dbline 0 ; func end
	adiw R28,1
	xjmp pop_xgset30FC
	.dbsym r length 12 i
	.dbsym r address 10 i
	.dbsym r inchar 14 c
	.dbend
	.dbfunc e checkcrc _checkcrc fI
;        cycbyte -> <dead>
	.even
_checkcrc::
	st -y,r17
	st -y,r16
	.dbline -1
	.dbline 467
; 	    }
; }
; 
; 
; // Check intelbinary CRC 
; int checkcrc(unsigned char cycbyte)
; {
	.dbline 468
; 	GetByteHex();
	xcall _GetByteHex
	.dbline 469
;  	return 1;
	ldi R16,1
	ldi R17,0
	.dbline -2
L148:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbsym l cycbyte 0 c
	.dbend
	.dbfunc e DecodeIntelHex _DecodeIntelHex fI
;    addressbyte -> <dead>
;           strg -> y+0
;         inbyte -> R10
;              i -> R20,R21
	.even
_DecodeIntelHex::
	xcall push_xgset303C
	sbiw R28,8
	.dbline -1
	.dbline 484
; }
; 
; // Convert Intel Hex ASCII string to binary
; //
; // :10 0100 00 0C948F0D0C941D0E0C941D0E0C941D0E 38
; // :1001000000C941D0E0C941D0E0C944E590C941D0E38
; // This routine decodes a line of Intel Hex.  Other 
; // routines write the data to either AVR Flash, external Flash
; // or AVR EEPROM
; //
; //   :02 0000 04 0000FA  - IntelHex32 super address record
; // 
; //  TBD - check crc byte - drop record if incorrect
; int DecodeIntelHex(void)
; {
	.dbline 488
;  	 unsigned char strg[8],addressbyte,inbyte;
; 	 int i;
; 	 
; 	 putcharr(':');
	ldi R16,58
	xcall _putcharr
	.dbline 490
; 	 // Convert count of bytes on line
; 	 bytesonline = GetByteHex();
	xcall _GetByteHex
	mov R2,R16
	clr R3
	sts _bytesonline+1,R3
	sts _bytesonline,R2
	.dbline 494
; 	 
; 	 // Convert address to binary - ignore filler byte
; 	 // Typical Intel Hex consists of 4 ASCII characters
; 	 inteladdress = GetByteHex()*256;
	xcall _GetByteHex
	mov R18,R16
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	sts _inteladdress+1,R17
	sts _inteladdress,R16
	.dbline 495
; 	 inteladdress += GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	mov R2,R12
	clr R3
	lds R4,_inteladdress
	lds R5,_inteladdress+1
	add R4,R2
	adc R5,R3
	sts _inteladdress+1,R5
	sts _inteladdress,R4
	.dbline 498
; 	 
; 	 // Read dump byte (2 characters)
; 	 intelrecordcommand = GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	sts _intelrecordcommand,R12
	.dbline 500
; 	 
; 	 if(intelrecordcommand==0x04) {
	cpi R16,4
	brne L150
X57:
	.dbline 500
	.dbline 501
; 	     intelsuperaddress = GetByteHex()*256;
	xcall _GetByteHex
	mov R12,R16
	mov R18,R12
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	sts _intelsuperaddress+1,R17
	sts _intelsuperaddress,R16
	.dbline 502
; 		 intelsuperaddress += GetByteHex();
	xcall _GetByteHex
	mov R12,R16
	mov R2,R12
	clr R3
	lds R4,_intelsuperaddress
	lds R5,_intelsuperaddress+1
	add R4,R2
	adc R5,R3
	sts _intelsuperaddress+1,R5
	sts _intelsuperaddress,R4
	.dbline 503
; 		 }
	xjmp L151
L150:
	.dbline 504
; 	 else  {
	.dbline 506
; 	     // Convert all data to binary
; 	     for(i=0; i<bytesonline; i++) {
	clr R20
	clr R21
	xjmp L155
L152:
	.dbline 506
	.dbline 507
; 		     inbyte = GetByteHex(strg);
	movw R16,R28
	xcall _GetByteHex
	mov R12,R16
	mov R10,R12
	.dbline 508
; 		     intelbinary[i] = inbyte;
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	movw R30,R20
	add R30,R24
	adc R31,R25
	std z+0,R10
	.dbline 509
; 	 	     }
L153:
	.dbline 506
	subi R20,255  ; offset = 1
	sbci R21,255
L155:
	.dbline 506
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	cp R20,R2
	cpc R21,R3
	brlo L152
X58:
	.dbline 510
; 		 }
L151:
	.dbline 513
; 		 
; 	// Check CRC - todo
; 	if(checkcrc(inbyte)) return 1;
	mov R16,R10
	xcall _checkcrc
	movw R10,R16
	cpi R16,0
	cpc R16,R17
	breq L156
X59:
	.dbline 513
	ldi R16,1
	ldi R17,0
	xjmp L149
L156:
	.dbline 514
; 	else return -1;
	ldi R16,-1
	ldi R17,-1
	.dbline -2
L149:
	.dbline 0 ; func end
	adiw R28,8
	xjmp pop_xgset303C
	.dbsym l addressbyte 1 c
	.dbsym l strg 0 A[8:8]c
	.dbsym r inbyte 10 c
	.dbsym r i 20 I
	.dbend
	.dbfunc e ProgramEEPROM _ProgramEEPROM fV
;              i -> R10
	.even
_ProgramEEPROM::
	st -y,R10
	.dbline -1
	.dbline 519
; }
; 
; //  Write decoded Intel hex to EEPROM
; void ProgramEEPROM(void)
; {
	.dbline 522
;      unsigned char i;
; 	 
; 	 for(i=0; i<bytesonline; i++)  EEPROMWrite(inteladdress+i,intelbinary[i]);
	clr R10
	xjmp L162
L159:
	.dbline 522
	ldi R24,<_intelbinary
	ldi R25,>_intelbinary
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	mov R2,R10
	clr R3
	lds R16,_inteladdress
	lds R17,_inteladdress+1
	add R16,R2
	adc R17,R3
	xcall _EEPROMWrite
L160:
	.dbline 522
	inc R10
L162:
	.dbline 522
	lds R2,_bytesonline
	lds R3,_bytesonline+1
	mov R4,R10
	clr R5
	cp R4,R2
	cpc R5,R3
	brlo L159
X60:
	.dbline -2
L158:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r i 10 c
	.dbend
	.dbfunc e ProgramAVRFlash _ProgramAVRFlash fV
;         inchar -> R10
	.even
_ProgramAVRFlash::
	st -y,R10
	.dbline -1
	.dbline 527
; }
; 
; //  TBD - AVR Flash hold program so programming AVR flash may overwrite program
; void ProgramAVRFlash(void)
; {
	xjmp L165
L164:
	.dbline 530
;  	 char inchar;
; 	 
;  	 while((inchar=getcharr())!=CR) putcharr(inchar);
	mov R16,R10
	xcall _putcharr
L165:
	.dbline 530
	xcall _getcharr
	mov R10,R16
	cpi R16,13
	brne L164
X61:
	.dbline 531
; 	 printf("\n-");
	ldi R16,<L167
	ldi R17,>L167
	xcall _printf
	.dbline -2
L163:
	.dbline 0 ; func end
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e CleanUpFlashState _CleanUpFlashState fV
	.even
_CleanUpFlashState::
	.dbline -1
	.dbline 535
; }
; 
; void CleanUpFlashState()
; {
	.dbline 536
; 	if(flashdatainbuffer==YES)  {
	lds R24,_flashdatainbuffer
	cpi R24,1
	brne L169
X62:
	.dbline 536
	.dbline 537
; 	    inteladdress = oldinteladdress;  // end of file record destroyed intelad
	lds R2,_oldinteladdress
	lds R3,_oldinteladdress+1
	sts _inteladdress+1,R3
	sts _inteladdress,R2
	.dbline 538
; 	    ProgramBuffertoPageErase(1);
	ldi R16,1
	xcall _ProgramBuffertoPageErase
	.dbline 539
; 		WaitForFlashFree();
	xcall _WaitForFlashFree
	.dbline 540
; 		}
L169:
	.dbline 541
; 	if(flashprogrammingactive==YES)  {
	lds R24,_flashprogrammingactive
	cpi R24,1
	brne L171
X63:
	.dbline 541
	.dbline 542
; 		Release_SPI();
	xcall _Release_SPI
	.dbline 543
; 		flashprogrammingactive = NO;
	clr R2
	sts _flashprogrammingactive,R2
	.dbline 544
; 		flashpageloaded = NO;
	sts _flashpageloaded,R2
	.dbline 545
; 		flashpageboundarytraversed = NO;
	sts _flashpageboundarytraversed,R2
	.dbline 546
; 		flashdatainbuffer = NO;
	sts _flashdatainbuffer,R2
	.dbline 547
; 		}
L171:
	.dbline -2
L168:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ProgramMemory _ProgramMemory fV
	.even
_ProgramMemory::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 559
; }
; 
; //  Main memory programming selection function
; //  Program EEPROM, AVR Flash or SPI Flash.
; //  Three IntelHex32 Records 0x00, 0x01 and 0x04 are processed by this
; //  routine.  0x00 is a data record, 0x01 is End of File record and 
; //  0x04 is extended address record
; //
; //  TBD - no intel record time out - reset defaults if not intel 
; //        records received after 3 seconds
; void ProgramMemory(void)
; {
	.dbline 560
;  	DecodeIntelHex();
	xcall _DecodeIntelHex
	.dbline 561
; 	switch (programmode) {
	lds R20,_programmode
	clr R21
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L180
X64:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L177
X65:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L183
X66:
	xjmp L174
L177:
	.dbline 563
; 	    case LEEPROM:
; 			if(intelrecordcommand==0) ProgramEEPROM();
	lds R2,_intelrecordcommand
	tst R2
	brne L175
X67:
	.dbline 563
	xcall _ProgramEEPROM
	.dbline 564
; 			break;
	xjmp L175
L180:
	.dbline 566
; 		case LAVRFLASH:
; 		    if(intelrecordcommand==0) ProgramAVRFlash();
	lds R2,_intelrecordcommand
	tst R2
	brne L175
X68:
	.dbline 566
	xcall _ProgramAVRFlash
	.dbline 567
; 			break;
	xjmp L175
L183:
	.dbline 580
; 			
; 		//  To access Blackfin Flash the Blackfin must not have control 
; 		//  of the shared SPI lines and the Blackfin reset line must not
; 		//  be active.  The Blackfin releases control of the SPI lines under 
; 		//  software control or by being forced to boot mode 0.  If the Blackfin
; 		//  is reset to boot mode 3 it will attempt to load a program from 
; 		//  serial flash preventing the AVR from accessing the serial flash.
; 		
; 		//  This implementation forces the Blackfin to reboot.
; 		//  Cooperative flash access still TBD
; 		case LFLASH:
; 		    // Data record			
; 			if(intelrecordcommand==0) {
	lds R2,_intelrecordcommand
	tst R2
	brne L184
X69:
	.dbline 580
	.dbline 581
; 			    flashcountdown = 3000;  // 3 second no new Hex record timeout
	ldi R24,3000
	ldi R25,11
	sts _flashcountdown+1,R25
	sts _flashcountdown,R24
	.dbline 583
; 			    //  See is SPI Master is active - set active if not
; 			    if(flashprogrammingactive==NO) {
	lds R2,_flashprogrammingactive
	tst R2
	brne L186
X70:
	.dbline 583
	.dbline 584
; 				    Init_SPI_Master();
	xcall _Init_SPI_Master
	.dbline 585
; 					}
L186:
	.dbline 587
; 					
; 		        ProgramSerialFlash();		
	xcall _ProgramSerialFlash
	.dbline 588
; 				}
	xjmp L175
L184:
	.dbline 590
; 			// Extended address record
; 			else if(intelrecordcommand==0x04) ; // nothing to do
	lds R24,_intelrecordcommand
	cpi R24,4
	brne L188
X71:
	.dbline 590
	xjmp L175
L188:
	.dbline 593
; 			
; 			// End of File record - reset all variables
; 			else if(intelrecordcommand==0x01) CleanUpFlashState();
	lds R24,_intelrecordcommand
	cpi R24,1
	brne L175
X72:
	.dbline 593
	xcall _CleanUpFlashState
	.dbline 594
; 			break;
L174:
L175:
	.dbline -2
L173:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbend
	.dbfunc e LoadMemory _LoadMemory fV
;         inchar -> R10
	.even
_LoadMemory::
	xcall push_xgset300C
	.dbline -1
	.dbline 601
; 		} 
; }
; 
; //  Set default memory programming mode
; //  Subsequent Intel Hex dumps will load to the specific memory
; void LoadMemory(void)
; {
	.dbline 604
;     unsigned char inchar;
; 	
; 	inchar = getcharr();
	xcall _getcharr
	mov R10,R16
	.dbline 605
; 	putcharr(inchar);
	xcall _putcharr
	.dbline 606
; 	switch (inchar) {
	mov R20,R10
	clr R21
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	breq L198
X73:
	cpi R20,69
	ldi R30,0
	cpc R21,R30
	breq L196
X74:
	cpi R20,70
	ldi R30,0
	cpc R21,R30
	breq L197
X75:
	cpi R20,65
	ldi R30,0
	cpc R21,R30
	brlt L194
X76:
L199:
	cpi R20,97
	ldi R30,0
	cpc R21,R30
	breq L198
X77:
	cpi R20,101
	ldi R30,0
	cpc R21,R30
	breq L196
X78:
	cpi R20,102
	ldi R30,0
	cpc R21,R30
	breq L197
X79:
	xjmp L194
L196:
	.dbline 608
; 	    case 'e': case 'E':
; 			programmode = LEEPROM;
	ldi R24,101
	sts _programmode,R24
	.dbline 609
; 			putfs(loadmessage1);
	ldi R16,<_loadmessage1
	ldi R17,>_loadmessage1
	xcall _putfs
	.dbline 610
; 		    break;
	xjmp L194
L197:
	.dbline 612
; 		case 'f': case 'F':
; 			programmode = LFLASH;
	ldi R24,102
	sts _programmode,R24
	.dbline 613
; 			putfs(loadmessage2);
	ldi R16,<_loadmessage2
	ldi R17,>_loadmessage2
	xcall _putfs
	.dbline 614
; 		    break;
	xjmp L194
L198:
	.dbline 616
; 		case 'a': case 'A':
; 			programmode = LAVRFLASH;
	ldi R24,97
	sts _programmode,R24
	.dbline 617
; 		    putfs(loadmessage3);
	ldi R16,<_loadmessage3
	ldi R17,>_loadmessage3
	xcall _putfs
	.dbline 618
; 		    break;
	.dbline 620
; 		default:
; 		   break;
L194:
	.dbline -2
L192:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r inchar 10 c
	.dbend
	.area lit(rom, con, rel)
L201:
	.byte 48,46,57,49,0
	.area text(rom, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
	.dbfunc e ProgramVersion _ProgramVersion fV
;        version -> y+0
	.even
_ProgramVersion::
	sbiw R28,5
	.dbline -1
	.dbline 627
; 	    }
; }
; 
; //  Output program version
; //   TBD - read from EEPROM
; void ProgramVersion(void)
; {
	.dbline 628
;       char version[5]="0.91";
	ldi R24,<L201
	ldi R25,>L201
	movw R30,R28
	ldi R16,5
	ldi R17,0
	st -y,R31
	st -y,R30
	st -y,R25
	st -y,R24
	xcall asgncblk
	.dbline 630
; 	  
; 	  putfs(progmessage);
	ldi R16,<_progmessage
	ldi R17,>_progmessage
	xcall _putfs
	.dbline 631
; 	  puts(version);
	movw R16,R28
	xcall _puts
	.dbline 632
; 	  putCRLF();
	xcall _putCRLF
	.dbline -2
L200:
	.dbline 0 ; func end
	adiw R28,5
	ret
	.dbsym l version 0 A[5:5]c
	.dbend
	.dbfunc e AnalogCh _AnalogCh fI
;           high -> R12
;            low -> R10
;           mode -> R20
;             ch -> R22,R23
	.even
_AnalogCh::
	xcall push_xgsetF03C
	mov R20,R18
	movw R22,R16
	.dbline -1
	.dbline 638
; }
; 
; //  Read selected analog channel - wait until it completes
; //   TBD - background interrupt process
; int AnalogCh(int ch,char mode)
; {
	.dbline 641
;  	unsigned char low,high;
; 	
; 	if(ch==0) ADMUX = 0x00;  // Select AVCC, ch 0
	cpi R22,0
	cpc R22,R23
	brne L203
X80:
	.dbline 641
	clr R2
	sts 124,R2
	xjmp L204
L203:
	.dbline 642
; 	else if(ch==1) ADMUX = 0x01; // 
	cpi R22,1
	ldi R30,0
	cpc R23,R30
	brne L205
X81:
	.dbline 642
	ldi R24,1
	sts 124,R24
	xjmp L206
L205:
	.dbline 643
; 	else if(ch==2) ADMUX = 0x02;
	cpi R22,2
	ldi R30,0
	cpc R23,R30
	brne L207
X82:
	.dbline 643
	ldi R24,2
	sts 124,R24
	xjmp L208
L207:
	.dbline 644
; 	else if(ch==3) ADMUX = 0x03;
	cpi R22,3
	ldi R30,0
	cpc R23,R30
	brne L209
X83:
	.dbline 644
	ldi R24,3
	sts 124,R24
	xjmp L210
L209:
	.dbline 645
; 	else if(ch==4) ADMUX = 0x04; 
	cpi R22,4
	ldi R30,0
	cpc R23,R30
	brne L211
X84:
	.dbline 645
	ldi R24,4
	sts 124,R24
	xjmp L212
L211:
	.dbline 646
; 	else if(ch==5) ADMUX = 0x05;
	cpi R22,5
	ldi R30,0
	cpc R23,R30
	brne L213
X85:
	.dbline 646
	ldi R24,5
	sts 124,R24
	xjmp L214
L213:
	.dbline 647
; 	else if(ch==6) ADMUX = 0x06;
	cpi R22,6
	ldi R30,0
	cpc R23,R30
	brne L215
X86:
	.dbline 647
	ldi R24,6
	sts 124,R24
	xjmp L216
L215:
	.dbline 648
; 	else if(ch==7) ADMUX = 0x07;
	cpi R22,7
	ldi R30,0
	cpc R23,R30
	brne L217
X87:
	.dbline 648
	ldi R24,7
	sts 124,R24
	xjmp L218
L217:
	.dbline 649
; 	else if(ch==8) ADMUX = 0x0C;  // Boost ADC2 gain by 10x
	cpi R22,8
	ldi R30,0
	cpc R23,R30
	brne L219
X88:
	.dbline 649
	ldi R24,12
	sts 124,R24
L219:
L218:
L216:
L214:
L212:
L210:
L208:
L206:
L204:
	.dbline 650
; 	if(mode==INTERNALREF)  ADMUX |= 0xC0;
	cpi R20,105
	brne L221
X89:
	.dbline 650
	lds R24,124
	ori R24,192
	sts 124,R24
	xjmp L222
L221:
	.dbline 651
; 	else ADMUX |= 0x40;  // use AVCC
	lds R24,124
	ori R24,64
	sts 124,R24
L222:
	.dbline 653
; 	
; 	ADCSRA = (1<<ADEN)|(1<<ADSC); // Enable ADC, start conversion, max clock
	ldi R24,192
	sts 122,R24
L223:
	.dbline 654
; 	while(!(ADCSRA&(1<<ADIF))) ; // loop until conversion completes
L224:
	.dbline 654
	lds R2,122
	sbrs R2,4
	rjmp L223
X90:
	.dbline 655
; 	shortdelay(10);
	ldi R16,10
	ldi R17,0
	xcall _shortdelay
	.dbline 657
; 	
; 	low = ADCL;
	lds R10,120
	.dbline 658
; 	high = ADCH;
	lds R12,121
	.dbline 659
; 	return (low + (high*256));
	mov R18,R12
	clr R19
	ldi R16,256
	ldi R17,1
	xcall empy16s
	movw R2,R16
	mov R16,R10
	clr R17
	add R16,R2
	adc R17,R3
	.dbline -2
L202:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym r high 12 c
	.dbsym r low 10 c
	.dbsym r mode 20 c
	.dbsym r ch 22 I
	.dbend
	.dbfunc e DumpAnalogChs _DumpAnalogChs fV
;    analogvalue -> R10,R11
;              i -> R20,R21
	.even
_DumpAnalogChs::
	xcall push_xgset300C
	.dbline -1
	.dbline 663
; }
; 
; void DumpAnalogChs(void)
; {
	.dbline 666
;     int  i,analogvalue;
; 	
; 	printf("Analog Channels 0..7\n");
	ldi R16,<L227
	ldi R17,>L227
	xcall _printf
	.dbline 667
;  	for(i=0; i<8; i++) {
	clr R20
	clr R21
L228:
	.dbline 667
	.dbline 668
; 	    analogvalue = AnalogCh(i,EXTERNALREF);
	ldi R18,101
	movw R16,R20
	xcall _AnalogCh
	movw R10,R16
	.dbline 669
; 		printf("%d ",analogvalue);
	movw R18,R10
	ldi R16,<L232
	ldi R17,>L232
	xcall _printf
	.dbline 670
; 		} 
L229:
	.dbline 667
	subi R20,255  ; offset = 1
	sbci R21,255
	.dbline 667
	cpi R20,8
	ldi R30,0
	cpc R21,R30
	brlt L228
X91:
	.dbline 671
; 	printf("\n"); 
	ldi R16,<L233
	ldi R17,>L233
	xcall _printf
	.dbline -2
L226:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r analogvalue 10 I
	.dbsym r i 20 I
	.dbend
	.dbfunc e readint _readint fI
;         intnum -> R20,R21
;         endptr -> R10,R11
;      incharbuf -> y+0
;              i -> R22,R23
;         inchar -> R10
	.even
_readint::
	xcall push_xgsetF03C
	sbiw R28,10
	.dbline -1
	.dbline 676
; }
; 
; // Collect characters until CR, LF or space found
; int readint()
; {
	.dbline 680
;  	char incharbuf[10],inchar;
; 	int  intnum,i,endptr;
; 	
; 	intnum = 0;
	clr R20
	clr R21
	.dbline 681
; 	i = 0;
	clr R22
	clr R23
	xjmp L236
L235:
	.dbline 683
; 	// Skip preceeding white space
; 	while((inchar=getcharr())==' ') putchar(inchar);
	mov R16,R10
	xcall _putchar$device_specific$
L236:
	.dbline 683
	xcall _getcharr
	mov R10,R16
	cpi R16,32
	breq L235
X92:
	.dbline 684
; 	putchar(inchar);
	xcall _putchar$device_specific$
	xjmp L239
L238:
	.dbline 685
; 	while((i<10)&&(inchar!=CR)&&(inchar!=LF)&&(inchar!=' ')) {
	.dbline 686
; 	    incharbuf[i++] = inchar;
	movw R2,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R24,R28
	movw R30,R2
	add R30,R24
	adc R31,R25
	std z+0,R10
	.dbline 687
; 		inchar = getcharr();
	xcall _getcharr
	mov R12,R16
	mov R10,R12
	.dbline 688
; 		putchar(inchar);
	xcall _putchar$device_specific$
	.dbline 689
; 		}
L239:
	.dbline 685
	cpi R22,10
	ldi R30,0
	cpc R23,R30
	brge L243
X93:
	mov R24,R10
	cpi R24,13
	breq L243
X94:
	cpi R24,10
	breq L243
X95:
	cpi R24,32
	brne L238
X96:
L243:
	.dbline 690
; 	incharbuf[i] = 0;
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	clr R2
	std z+0,R2
	.dbline 691
; 	endptr = strlen(incharbuf) - 1;
	movw R16,R28
	xcall _strlen
	movw R22,R16
	movw R24,R22
	sbiw R24,1
	movw R10,R24
	.dbline 692
; 	if(endptr>=0) intnum = (incharbuf[endptr--] - '0');
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L244
X97:
	.dbline 692
	movw R22,R24
	sbiw R24,1
	movw R10,R24
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R20,z+0
	clr R21
	subi R20,48
	sbci R21,0
L244:
	.dbline 693
; 	if(endptr>=0) intnum += (incharbuf[endptr--] - '0')*10;
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L246
X98:
	.dbline 693
	movw R22,R24
	sbiw R24,1
	movw R10,R24
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,10
	mul R24,R2
	movw R24,R0
	subi R24,224
	sbci R25,1
	add R20,R24
	adc R21,R25
L246:
	.dbline 694
; 	if(endptr>=0) intnum += (incharbuf[endptr--] - '0')*100;
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L248
X99:
	.dbline 694
	movw R22,R24
	sbiw R24,1
	movw R10,R24
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R2,z+0
	ldi R24,100
	mul R24,R2
	movw R24,R0
	subi R24,192
	sbci R25,18
	add R20,R24
	adc R21,R25
L248:
	.dbline 695
; 	if(endptr>=0) intnum += (incharbuf[endptr--] - '0')*1000;
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L250
X100:
	.dbline 695
	movw R22,R24
	sbiw R24,1
	movw R10,R24
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	clr R19
	ldi R16,1000
	ldi R17,3
	xcall empy16s
	movw R24,R16
	subi R24,128
	sbci R25,187
	add R20,R24
	adc R21,R25
L250:
	.dbline 696
; 	if(endptr>=0) intnum = (incharbuf[endptr--] - '0')*10000;	
	movw R24,R10
	cpi R24,0
	ldi R30,0
	cpc R25,R30
	brlt L252
X101:
	.dbline 696
	movw R22,R24
	sbiw R24,1
	movw R10,R24
	movw R24,R28
	movw R30,R22
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	clr R19
	ldi R16,10000
	ldi R17,39
	xcall empy16s
	movw R20,R16
	subi R20,0
	sbci R21,83
L252:
	.dbline 697
; 	return intnum;
	movw R16,R20
	.dbline -2
L234:
	.dbline 0 ; func end
	adiw R28,10
	xjmp pop_xgsetF03C
	.dbsym r intnum 20 I
	.dbsym r endptr 10 I
	.dbsym l incharbuf 0 A[10:10]c
	.dbsym r i 22 I
	.dbsym r inchar 10 c
	.dbend
	.dbfunc e getint _getint fc
;       intvalue -> R20
;         inchar -> R22
	.even
_getint::
	st -y,R20
	st -y,R22
	.dbline -1
	.dbline 701
; }
; 
; char getint()
; {
	.dbline 704
; 	char intvalue,inchar;
; 	
; 	inchar = getcharr();
	xcall _getcharr
	mov R22,R16
	.dbline 705
; 	putcharr(inchar);
	xcall _putcharr
	.dbline 706
; 	if(inchar==CR) return 0x78;
	cpi R22,13
	brne L255
X102:
	.dbline 706
	ldi R16,120
	xjmp L254
L255:
	.dbline 707
; 	intvalue = (inchar - '0')*10;
	ldi R24,10
	mul R24,R22
	mov R20,R0
	subi R20,224
	.dbline 708
; 	inchar = getcharr();
	xcall _getcharr
	mov R22,R16
	.dbline 709
; 	putcharr(inchar);	
	xcall _putcharr
	.dbline 710
; 	intvalue = intvalue + (inchar-'0');
	mov R24,R22
	subi R24,48
	add R20,R24
	.dbline 711
; 	return intvalue;
	mov R16,R20
	.dbline -2
L254:
	.dbline 0 ; func end
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r intvalue 20 c
	.dbsym r inchar 22 c
	.dbend
	.dbfunc e getsettime _getsettime fV
;         inchar -> R10
;         instrg -> y+6
	.even
_getsettime::
	st -y,R10
	st -y,R12
	sbiw R28,10
	.dbline -1
	.dbline 716
; }
; 
; // Update the current day and time
; void  getsettime()
; {
	.dbline 719
;     unsigned char instrg[4],inchar;
; 	
;     _CLI();
	cli
	.dbline 720
; 	instrg[0] = days;
	lds R2,_days
	std y+6,R2
	.dbline 721
; 	instrg[1] = hours;
	lds R2,_hours
	std y+7,R2
	.dbline 722
; 	instrg[2] = minutes;
	lds R2,_minutes
	std y+8,R2
	.dbline 723
; 	instrg[3] = seconds;
	lds R2,_seconds
	std y+9,R2
	.dbline 724
; 	_SEI();	
	sei
	.dbline 726
; 	
; 	printf("Set time [hh:mm:ss]=%d %d:%d:%d :",
	clr R3
	std y+5,R3
	std y+4,R2
	ldd R2,y+8
	clr R3
	std y+3,R3
	std y+2,R2
	ldd R2,y+7
	clr R3
	std y+1,R3
	std y+0,R2
	ldd R18,y+6
	clr R19
	ldi R16,<L261
	ldi R17,>L261
	xcall _printf
	.dbline 729
; 	   		instrg[0],instrg[1],instrg[2],instrg[3]);
; 
; 	if((instrg[1]=getint())==0x78) return;
	xcall _getint
	std y+7,R16
	cpi R16,120
	brne L265
X103:
	.dbline 729
	xjmp L257
L265:
	.dbline 730
; 	inchar = getcharr(); putcharr(inchar);
	xcall _getcharr
	.dbline 730
	xcall _putcharr
	.dbline 731
; 	instrg[2] = getint();
	xcall _getint
	mov R12,R16
	std y+8,R12
	.dbline 732
; 	inchar = getcharr(); putcharr(inchar);
	xcall _getcharr
	.dbline 732
	xcall _putcharr
	.dbline 733
; 	instrg[3] = getint();
	xcall _getint
	mov R12,R16
	std y+9,R12
	.dbline 734
; 	inchar = getcharr(); putcharr(inchar);
	xcall _getcharr
	mov R12,R16
	mov R10,R12
	.dbline 734
	xcall _putcharr
	.dbline 736
; 
;     _CLI();
	cli
	.dbline 737
; 	days = 0;
	clr R2
	sts _days,R2
	.dbline 738
; 	hours = instrg[1];
	ldd R2,y+7
	sts _hours,R2
	.dbline 739
; 	minutes = instrg[2];
	ldd R2,y+8
	sts _minutes,R2
	.dbline 740
; 	seconds = instrg[3];
	ldd R2,y+9
	sts _seconds,R2
	.dbline 741
; 	_SEI();	
	sei
	.dbline -2
L257:
	.dbline 0 ; func end
	adiw R28,10
	ld R12,y+
	ld R10,y+
	ret
	.dbsym r inchar 10 c
	.dbsym l instrg 6 A[4:4]c
	.dbend
	.dbfunc e TestAVR _TestAVR fV
;              j -> R20
;              i -> R22
	.even
_TestAVR::
	xcall push_xgsetF000
	.dbline -1
	.dbline 746
; }
; 
; //  Simple test routine
; void TestAVR(void)
; {
	.dbline 749
;  	 char i,j;
; 	 
;  	 printf("\nTesting AVR Version 0.34\n");
	ldi R16,<L274
	ldi R17,>L274
	xcall _printf
	.dbline 754
; //	 TestAVRRAM();
; //	 TestAVREEPROM();
; //	 TestAVRFLASH();
; //	 TestBoardFLASH():
; 	 j = 0;
	clr R20
	.dbline 755
; 	 putcharr(' ');
	ldi R16,32
	xcall _putcharr
	.dbline 756
; 	 for(i=0x20; i<0x7f; i++) {
	ldi R22,32
	xjmp L278
L275:
	.dbline 756
	.dbline 757
; 	 	 putcharr(i);
	mov R16,R22
	xcall _putcharr
	.dbline 758
; 		 if(j++ == 60)  {
	mov R2,R20
	clr R3
	subi R20,255    ; addi 1
	mov R24,R2
	cpi R24,60
	brne L279
X104:
	.dbline 758
	.dbline 759
; 		     j = 0;
	clr R20
	.dbline 760
; 			 printf("\n ");
	ldi R16,<L281
	ldi R17,>L281
	xcall _printf
	.dbline 761
; 			 }
L279:
	.dbline 762
; 		 }
L276:
	.dbline 756
	inc R22
L278:
	.dbline 756
	cpi R22,127
	brlo L275
X105:
	.dbline 763
; 	 printf("\n ");
	ldi R16,<L281
	ldi R17,>L281
	xcall _printf
	.dbline 764
; 	 DumpAnalogChs();
	xcall _DumpAnalogChs
	.dbline -2
L273:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r j 20 c
	.dbsym r i 22 c
	.dbend
	.dbfunc e EEPROM_write _EEPROM_write fV
;         ucData -> R18
;      uiAddress -> R16,R17
	.even
_EEPROM_write::
	.dbline -1
	.dbline 768
; }
; 
; void  EEPROM_write(int uiAddress,unsigned char ucData)
; {
L283:
	.dbline 770
;     //  Wait for completion of previous write
; 	while(EECR&(1<<EEPE));
L284:
	.dbline 770
	sbic 0x1f,1
	rjmp L283
X106:
	.dbline 773
; 	
; 	// Set up address and Data registers
; 	EEAR = uiAddress;
	out 0x22,R17
	out 0x21,R16
	.dbline 774
; 	EEDR = ucData;
	out 0x20,R18
	.dbline 777
; 	
; 	// Write logical one to EEMPE
; 	EECR |= (1<<EEMPE);
	sbi 0x1f,2
	.dbline 780
; 	
; 	// Start eeprom write by setting EEPE
; 	EECR |= (1<<EEPE);
	sbi 0x1f,1
	.dbline -2
L282:
	.dbline 0 ; func end
	ret
	.dbsym r ucData 18 c
	.dbsym r uiAddress 16 I
	.dbend
	.dbfunc e EEPROM_read _EEPROM_read fc
;      uiAddress -> R16,R17
	.even
_EEPROM_read::
	.dbline -1
	.dbline 784
; }
; 
; unsigned char EEPROM_read(int uiAddress)
; {
L287:
	.dbline 786
;     // Wait for completion of previous write
; 	while(EECR&(1<<EEPE));
L288:
	.dbline 786
	sbic 0x1f,1
	rjmp L287
X107:
	.dbline 789
; 	
; 	// Setup address
; 	EEAR = uiAddress;
	out 0x22,R17
	out 0x21,R16
	.dbline 792
; 	
; 	// Start eeprom read by writing EERE
; 	EECR |= (1<<EERE);
	sbi 0x1f,0
	.dbline 795
; 	
; 	// Return data from data register
; 	return EEDR;
	in R16,0x20
	.dbline -2
L286:
	.dbline 0 ; func end
	ret
	.dbsym r uiAddress 16 I
	.dbend
	.dbfunc e WriteEepromSignature _WriteEepromSignature fV
	.even
_WriteEepromSignature::
	.dbline -1
	.dbline 800
; }
; 
; //  Signature bytes are write to first five EEPROM locations 85 C2 1E 4F 11
; void WriteEepromSignature(void)
; {
	.dbline 801
;     EEPROM_write(0,0x85);
	ldi R18,133
	clr R16
	clr R17
	xcall _EEPROM_write
	.dbline 802
;     EEPROM_write(1,0xC2);
	ldi R18,194
	ldi R16,1
	ldi R17,0
	xcall _EEPROM_write
	.dbline 803
;     EEPROM_write(2,0x1E);
	ldi R18,30
	ldi R16,2
	ldi R17,0
	xcall _EEPROM_write
	.dbline 804
;     EEPROM_write(3,0x4F);
	ldi R18,79
	ldi R16,3
	ldi R17,0
	xcall _EEPROM_write
	.dbline 805
;     EEPROM_write(4,0x11);
	ldi R18,17
	ldi R16,4
	ldi R17,0
	xcall _EEPROM_write
	.dbline -2
L290:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e WriteEepromInt _WriteEepromInt fV
	.dbunion 1 2 u_tag
	.dbfield 0 iivalue I
	.dbfield 0 intchar A[2:2]c
	.dbend
;              u -> y+0
;         ivalue -> R10,R11
;        address -> R20,R21
	.even
_WriteEepromInt::
	xcall push_xgset300C
	movw R10,R18
	movw R20,R16
	sbiw R28,2
	.dbline -1
	.dbline 809
; }
; 
; void WriteEepromInt(int address,int ivalue)
; {
	.dbline 815
;     union u_tag {
; 	    int iivalue;
; 		unsigned char intchar[2];
; 		} u;
; 	
; 	u.iivalue = ivalue;
	std y+1,R11
	std y+0,R10
	.dbline 816
;  	EEPROM_write(address++,u.intchar[0]);
	mov R18,R10
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_write
	.dbline 817
;  	EEPROM_write(address,u.intchar[1]);	
	ldd R18,y+1
	movw R16,R20
	xcall _EEPROM_write
	.dbline -2
L291:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
	.dbsym l u 0 S[u_tag]
	.dbsym r ivalue 10 I
	.dbsym r address 20 I
	.dbend
	.dbfunc e WriteVersion _WriteVersion fV
	.even
_WriteVersion::
	.dbline -1
	.dbline 822
; }
; 
; // Write program version - offset address 5
; void WriteVersion(void)
; {
	.dbline 823
;     EEPROM_write(5,PRODUCTID);
	ldi R18,4
	ldi R16,5
	ldi R17,0
	xcall _EEPROM_write
	.dbline 824
; 	EEPROM_write(6,PROGRAMMAJORVER);
	clr R18
	ldi R16,6
	ldi R17,0
	xcall _EEPROM_write
	.dbline 825
; 	EEPROM_write(7,PROGRAMMINORVER);
	ldi R18,91
	ldi R16,7
	ldi R17,0
	xcall _EEPROM_write
	.dbline -2
L293:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e WriteCopyright _WriteCopyright fV
;            ptr -> R20
	.even
_WriteCopyright::
	st -y,R20
	.dbline -1
	.dbline 830
; }
; 
; // Write copyright notice - offset address 8
; void WriteCopyright(void)
; {
	.dbline 833
;     unsigned char ptr;
; 	
; 	for(ptr=8; ptr<(8+strlen(version)); ptr++)
	ldi R20,8
	xjmp L298
L295:
	.dbline 834
;           EEPROM_write(ptr,version[ptr-8]);
	ldi R24,<_version-8
	ldi R25,>_version-8
	mov R30,R20
	clr R31
	add R30,R24
	adc R31,R25
	ldd R18,z+0
	mov R16,R20
	clr R17
	xcall _EEPROM_write
L296:
	.dbline 833
	inc R20
L298:
	.dbline 833
	ldi R16,<_version
	ldi R17,>_version
	xcall _strlen
	movw R24,R16
	adiw R24,8
	mov R2,R20
	clr R3
	cp R2,R24
	cpc R3,R25
	brlo L295
X108:
	.dbline -2
L294:
	.dbline 0 ; func end
	ld R20,y+
	ret
	.dbsym r ptr 20 c
	.dbend
	.dbfunc e CheckEepromSignature _CheckEepromSignature fc
;         status -> R20
	.even
_CheckEepromSignature::
	st -y,R20
	st -y,R22
	.dbline -1
	.dbline 840
; }
; 
; // Check 5 signature bytes in first five locations of EEPROM
; //   Should be 85 C2 1E 4F 11
; unsigned char CheckEepromSignature(void)
; {
	.dbline 843
;  	unsigned char status;
; 	
; 	status = 1;
	ldi R20,1
	.dbline 844
; 	if(EEPROM_read(0)!=0x85) status = 0;
	clr R16
	clr R17
	xcall _EEPROM_read
	cpi R16,133
	breq L301
X109:
	.dbline 844
	clr R20
L301:
	.dbline 845
; 	if(EEPROM_read(1)!=0xC2) status = 0;
	ldi R16,1
	ldi R17,0
	xcall _EEPROM_read
	cpi R16,194
	breq L303
X110:
	.dbline 845
	clr R20
L303:
	.dbline 846
; 	if(EEPROM_read(2)!=0x1E) status = 0;
	ldi R16,2
	ldi R17,0
	xcall _EEPROM_read
	mov R22,R16
	cpi R16,30
	breq L305
X111:
	.dbline 846
	clr R20
L305:
	.dbline 847
; 	if(EEPROM_read(3)!=0x4F) status = 0;
	ldi R16,3
	ldi R17,0
	xcall _EEPROM_read
	mov R22,R16
	cpi R16,79
	breq L307
X112:
	.dbline 847
	clr R20
L307:
	.dbline 848
; 	if(EEPROM_read(4)!=0x11) status = 0;
	ldi R16,4
	ldi R17,0
	xcall _EEPROM_read
	mov R22,R16
	cpi R16,17
	breq L309
X113:
	.dbline 848
	clr R20
L309:
	.dbline 849
; 	return status;
	mov R16,R20
	.dbline -2
L300:
	.dbline 0 ; func end
	ld R22,y+
	ld R20,y+
	ret
	.dbsym r status 20 c
	.dbend
	.dbfunc e ReadEepromInt _ReadEepromInt fI
	.dbunion 1 2 u_tag
	.dbfield 0 ivalue I
	.dbfield 0 intchar A[2:2]c
	.dbend
;              u -> y+0
;        address -> R20,R21
	.even
_ReadEepromInt::
	xcall push_xgset300C
	movw R20,R16
	sbiw R28,2
	.dbline -1
	.dbline 853
; }
; 
; int ReadEepromInt(int address)
; {	
	.dbline 859
;     union u_tag {
; 	    int ivalue;
; 		unsigned char intchar[2];
; 		} u;
; 	
; 	u.intchar[0] = EEPROM_read(address++);
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_read
	std y+0,R16
	.dbline 860
; 	u.intchar[1] = EEPROM_read(address);
	movw R16,R20
	xcall _EEPROM_read
	mov R10,R16
	std y+1,R10
	.dbline 861
; 	return u.ivalue;	
	ldd R16,y+0
	ldd R17,y+1
	.dbline -2
L311:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
	.dbsym l u 0 S[u_tag]
	.dbsym r address 20 I
	.dbend
	.dbfunc e WriteEepromFloat _WriteEepromFloat fV
	.dbunion 1 4 u_tag
	.dbfield 0 ffvalue D
	.dbfield 0 floatchar A[4:4]c
	.dbend
;              u -> y+0
;         fvalue -> y+8
;        address -> R20,R21
	.even
_WriteEepromFloat::
	st -y,r19
	st -y,r18
	xcall push_xgsetF000
	movw R20,R16
	sbiw R28,4
	.dbline -1
	.dbline 865
; }
; 
; void  WriteEepromFloat(int address,float fvalue)
; {
	.dbline 871
;     union u_tag {
; 	    float ffvalue;
; 		unsigned char floatchar[4];
; 		} u;
; 	
; 	u.ffvalue = fvalue;
	ldd R2,y+8
	ldd R3,y+9
	ldd R4,y+10
	ldd R5,y+11
	std y+0,R2
	std y+1,R3
	std y+2,R4
	std y+3,R5
	.dbline 872
;  	EEPROM_write(address++,u.floatchar[0]);
	ldd R18,y+0
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_write
	.dbline 873
;  	EEPROM_write(address++,u.floatchar[1]);
	ldd R18,y+1
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_write
	.dbline 874
;  	EEPROM_write(address++,u.floatchar[2]);
	ldd R18,y+2
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_write
	.dbline 875
;  	EEPROM_write(address,u.floatchar[3]);	
	ldd R18,y+3
	movw R16,R20
	xcall _EEPROM_write
	.dbline -2
L313:
	.dbline 0 ; func end
	adiw R28,4
	xcall pop_xgsetF000
	adiw R28,2
	ret
	.dbsym l u 0 S[u_tag]
	.dbsym l fvalue 8 D
	.dbsym r address 20 I
	.dbend
	.dbfunc e ReadEepromFloat _ReadEepromFloat fD
	.dbunion 1 4 u_tag
	.dbfield 0 fvalue D
	.dbfield 0 floatchar A[4:4]c
	.dbend
;              u -> y+0
;        address -> R20,R21
	.even
_ReadEepromFloat::
	xcall push_xgsetF00C
	movw R20,R16
	sbiw R28,4
	.dbline -1
	.dbline 879
; }
; 
; float ReadEepromFloat(int address)
; {	
	.dbline 885
;     union u_tag {
; 	    float fvalue;
; 		unsigned char floatchar[4];
; 		} u;
; 	
; 	u.floatchar[0] = EEPROM_read(address++);
	movw R2,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R2
	xcall _EEPROM_read
	std y+0,R16
	.dbline 886
; 	u.floatchar[1] = EEPROM_read(address++);
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	std y+1,R10
	.dbline 887
; 	u.floatchar[2] = EEPROM_read(address++);
	movw R22,R20
	subi R20,255  ; offset = 1
	sbci R21,255
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	std y+2,R10
	.dbline 888
; 	u.floatchar[3] = EEPROM_read(address);
	movw R16,R20
	xcall _EEPROM_read
	mov R10,R16
	std y+3,R10
	.dbline 889
; 	return u.fvalue;	
	ldd R16,y+0
	ldd R17,y+1
	ldd R18,y+2
	ldd R19,y+3
	.dbline -2
L317:
	.dbline 0 ; func end
	adiw R28,4
	xjmp pop_xgsetF00C
	.dbsym l u 0 S[u_tag]
	.dbsym r address 20 I
	.dbend
	.dbfunc e LoadEepromPreferences _LoadEepromPreferences fV
;         inchar -> <dead>
;     addressptr -> R22,R23
	.even
_LoadEepromPreferences::
	xcall push_xgsetF00C
	.dbline -1
	.dbline 894
; }
; 
; //  Load all the Motor Controller Setup preferences from EEPROM
; void LoadEepromPreferences()
; {
	.dbline 898
;     unsigned char inchar;
;     int addressptr;
; 	
; 	addressptr = 33;
	ldi R22,33
	ldi R23,0
	.dbline 901
; 	
; 	// I2C Configuration
; 	i2cmode = EEPROM_read(addressptr++);
	movw R2,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R16,R2
	xcall _EEPROM_read
	sts _i2cmode,R16
	.dbline 902
; 	TWI_slaveAddress = EEPROM_read(addressptr);
	movw R16,R22
	xcall _EEPROM_read
	mov R10,R16
	sts _TWI_slaveAddress,R10
	.dbline 903
; 	TWI_masterAddress = EEPROM_read(addressptr++);
	movw R20,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R16,R20
	xcall _EEPROM_read
	mov R10,R16
	sts _TWI_masterAddress,R10
	.dbline 906
; 	
; 	// General Setup parameters
; 	defaultlograte = ReadEepromInt(addressptr);  addressptr += 2;
	movw R16,R22
	xcall _ReadEepromInt
	movw R10,R16
	sts _defaultlograte+1,R11
	sts _defaultlograte,R10
	.dbline 906
	subi R22,254  ; offset = 2
	sbci R23,255
	.dbline 907
; 	armpd2 = EEPROM_read(addressptr++);
	movw R20,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R16,R20
	xcall _EEPROM_read
	mov R10,R16
	sts _armpd2,R10
	.dbline 908
; 	data2log = EEPROM_read(addressptr++);
	movw R20,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R16,R20
	xcall _EEPROM_read
	mov R10,R16
	sts _data2log,R10
	.dbline -2
L321:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym l inchar 1 c
	.dbsym r addressptr 22 I
	.dbend
	.dbfunc e SaveEepromPreferences _SaveEepromPreferences fV
;     addressptr -> R22,R23
	.even
_SaveEepromPreferences::
	xcall push_xgsetF000
	.dbline -1
	.dbline 928
; 	
; /*	followstepdir = EEPROM_read(addressptr++);
; 
; 	
; 	// Smart command mode configuration
; 	recognizecommandmode = EEPROM_read(addressptr++);
; 	
; 	// Motor drive parameters
; 	resolution = ReadEepromFloat(addressptr); addressptr += 4;
; 	minpps = ReadEepromFloat(addressptr); addressptr += 4;
; 	maxpps = ReadEepromFloat(addressptr); addressptr += 4;
; 	ramprate = ReadEepromFloat(addressptr); addressptr += 4;
; 	feedrate = ReadEepromFloat(addressptr); addressptr += 4;
; 	feedratemax = ReadEepromFloat(addressptr); addressptr += 4;
; 	backlash = ReadEepromInt(addressptr);  addressptr += 2;*/
; }
; 
; // Save controller configuration information to EEPROM
; void SaveEepromPreferences()
; {
	.dbline 931
;     int addressptr;
; 
; 	addressptr = 33;
	ldi R22,33
	ldi R23,0
	.dbline 934
; 
; 	// I2C Configuration
; 	EEPROM_write(addressptr++,i2cmode);
	lds R18,_i2cmode
	movw R2,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R16,R2
	xcall _EEPROM_write
	.dbline 936
; //	EEPROM_write(addressptr++,TWI_slaveAddress);
; 	EEPROM_write(addressptr++,TWI_masterAddress);
	lds R18,_TWI_masterAddress
	movw R2,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R16,R2
	xcall _EEPROM_write
	.dbline 939
; 
; 	// General Setup parameters
; 	WriteEepromInt(addressptr,defaultlograte); addressptr += 2;
	lds R18,_defaultlograte
	lds R19,_defaultlograte+1
	movw R16,R22
	xcall _WriteEepromInt
	.dbline 939
	subi R22,254  ; offset = 2
	sbci R23,255
	.dbline 940
; 	EEPROM_write(addressptr++,armpd2);
	lds R18,_armpd2
	movw R20,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R16,R20
	xcall _EEPROM_write
	.dbline 941
; 	EEPROM_write(addressptr++,data2log);
	lds R18,_data2log
	movw R20,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R16,R20
	xcall _EEPROM_write
	.dbline -2
L322:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r addressptr 22 I
	.dbend
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
L281:
	.blkb 3
	.area idata
	.byte 10,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
L274:
	.blkb 27
	.area idata
	.byte 10,'T,'e,'s,'t,'i,'n,'g,32,'A,'V,'R,32,'V,'e,'r
	.byte 's,'i,'o,'n,32,48,46,51,52,10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
L261:
	.blkb 34
	.area idata
	.byte 'S,'e,'t,32,'t,'i,'m,'e,32,91,'h,'h,58,'m,'m,58
	.byte 's,'s,93,61,37,'d,32,37,'d,58,37,'d,58,37,'d,32
	.byte 58,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
L233:
	.blkb 2
	.area idata
	.byte 10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
L232:
	.blkb 4
	.area idata
	.byte 37,'d,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
L227:
	.blkb 22
	.area idata
	.byte 'A,'n,'a,'l,'o,'g,32,'C,'h,'a,'n,'n,'e,'l,'s,32
	.byte 48,46,46,55,10,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
L167:
	.blkb 3
	.area idata
	.byte 10,45,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
L60:
	.blkb 3
	.area idata
	.byte 32,32,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
L55:
	.blkb 3
	.area idata
	.byte 48,48,0
	.area data(ram, con, rel)
	.dbfile C:\DOCUME~1\stephen\Desktop\WORKIN~1\WASPDA~1.91\Wasp_Utilities.c
; 
; 	// Smart command mode configuration
; /*	EEPROM_write(addressptr++,recognizecommandmode);
; 	
; 	// Motor drive parameters
; 	WriteEepromFloat(addressptr,resolution); addressptr += 4;
; 
; 	WriteEepromInt(addressptr,backlash); addressptr += 2;*/
; }
